package me.demon.market;

import me.Demon.DemonPlugin.DemonAPI;
import me.demon.market.Event.MarketTradeEvent;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public abstract class MarketAPI {

    //拍下物品
    public static void BuyItemEvent(Player p, String key) {
        if (main.DataG.getString("Items." + key + ".Item") == null) {
            p.sendMessage(main.prefix + "很抱歉,其他玩家抢先一步拍走了这个珍贵的商品!");
            p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
            return;
        }
        FileConfiguration yml = main.DataG;
        String str = "Items." + key + ".";
        String playName = yml.getString(str + "Seller");
        if (p.getName().equalsIgnoreCase(playName)) {
            p.sendMessage(main.prefix + "很抱歉,您不能拍下自己的商品!");
            return;
        }
        String Type = yml.getString(str + "Type");
        int Money = yml.getInt(str + "Money");
        if (DemonAPI.hasMoney(p, Money)) {
            DemonAPI.takeMoney(p, Money);
            ItemStack items = yml.getItemStack(str + "Item").clone();
            p.getInventory().addItem(items);
            p.sendMessage(main.prefix + "当前金币余额为: §6$" + (int) DemonAPI.seeMoney(p) + ".0");
            p.sendMessage(main.prefix + "购买成功! 你获得了: " + items.getItemMeta().getDisplayName() + "§7§lx§f" + items.getAmount());
            p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
            yml.set("Items." + key, null);
            main.KeyList.remove(key);
            main.saveDataStatsConfig();
            //储存收益数据
            //  BankAPI.addMoney(playName, Money);
            Player dj_player = Bukkit.getPlayer(playName);
            if (dj_player != null) {
                dj_player.sendMessage(main.prefix + "玩家 §a" + p.getName() + " §f拍下了您上架的 §r" + items.getItemMeta().getDisplayName() + "§7§lx§f" + items.getAmount());
            }
            // 买下拍卖品的事件监听
            MarketTradeEvent event = new MarketTradeEvent(p, Money, items);
            Bukkit.getPluginManager().callEvent(event);
        } else {
            p.sendMessage(main.prefix + "你需要§6$" + new DecimalFormat(",###.##").format(Money) + "金币§f才能拍下此商品");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
        }
    }

    //拍下物品
    public static void DeleteItemEvent(Player p, String key) {
        if (main.DataG.getString("Items." + key + ".Item") == null) {
            p.sendMessage(main.prefix + "很抱歉,其他玩家抢先一步拍走了这个珍贵的商品!");
            p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
            return;
        }
        FileConfiguration yml = main.DataG;
        String str = "Items." + key + ".";
        ItemStack items = yml.getItemStack(str + "Item").clone();
        p.getInventory().addItem(items);
        p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
        yml.set("Items." + key, null);
        main.KeyList.remove(key);
        main.saveDataStatsConfig();
    }

    public static List<String> New_KeyList(String type) {
        List<String> stringList = new ArrayList<>();
        for (String key : main.KeyList) {
            ItemStack items = main.DataG.getItemStack("Items." + key + ".Item");
            String typeName = items.getType().name();
            if (type.equalsIgnoreCase("方块")) {
                if (items.getType().isBlock()) {
                    stringList.add(key);
                }
            } else if (main.getItemType.get(type) != null && main.getItemType.get(type).contains(typeName)) {
                stringList.add(key);
            } else {
                String item_Type = main.DataG.getString("Items." + key + ".ItemType");
                if (item_Type.equalsIgnoreCase(type)) {
                    stringList.add(key);
                }
            }
        }
        return stringList;
    }
}
